/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/SPAND/javasrc/SpandProxy/spandFilters/Url.java,v 1.1 1998/06/18 22:23:35 stemm Exp $ */
package spandFilters;

import java.util.StringTokenizer;


public class Url
{
    private String urlString = "";
    private String baseUrl = "";
    private boolean parsed = false;
    private String hostname;
    private String filename;
    private int port;
    private String protocol;

    public Url(String s) {
	urlString = s;
	baseUrl = "";
	// some checking....
	Parse();
    }

    public Url(String s, String base) {

	//	System.out.println("new url " + s + " " + base);
	if (base.charAt(base.length() - 1) !=  '/')
	    baseUrl = base + "/";
	else
	    baseUrl = base;

	if (s.indexOf (':') != -1)
	    urlString = s;
	else
	    urlString = baseUrl + s;
	// some checking
	Parse();
    }

    private void Parse() {

	parsed = true;
	
	String s = urlString;
	String tempStr;

	// protocol, host, port, path

	//	System.out.println("   " + s);
	// protocol
	if (s.indexOf (':') != -1) {
	    // there is a protocol
	    protocol = s.substring (0, s.indexOf (':', 0));
	    s = s.substring(s.indexOf (':', 0) + 1, s.length());
	} else 
	    protocol = "http";
	protocol.toLowerCase();

	//	System.out.println("   protocol: |" + protocol +"|");
	// hostname
	int hoststart = s.indexOf ("//", 0) + 2;
	if (hoststart != 1) {
	    int hostend = s.indexOf(':', hoststart);
	    if (hostend == -1)
		hostend = s.indexOf('/', hoststart);
	    if (hostend == -1)
		hostend = s.length();
	    hostname = s.substring (hoststart, hostend);
	    s = s.substring(hostend, s.length());
	} else
	    hostname = "";
	hostname.toLowerCase();

	//	System.out.println("   hostname: |" + hostname + "|");
	// port
	if (s.indexOf (':') != -1) {
	    // there is a port
	    int portend = s.indexOf('/',0);
	    //	    System.out.println("   portend = " + portend);
	    if (portend == -1)
		portend = s.length();
	    Integer foo = new Integer(s.substring(1, portend));
	    port = foo.intValue();
	    s = s.substring(portend, s.length());
	} else {
	    if (protocol.equals("http"))
		port = 80;
	    else if (protocol.equals("ftp"))
		port = 20;
	}

	//	System.out.println("   port: " + port);
	// path
	filename = s;
	if (filename == "") {
	    if (protocol == "http")
		filename = "index.html";
	    else
		filename = "/";
	}

	//	System.out.println("   path: " + filename + "\n");
    }

    public String GetHostname() { return hostname;}
    public String GetFilename() { return filename;}
    public String GetProtocol() { return protocol;}
    public int GetPort() { return port;}
}
