/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/Socket++/Utility.h,v 1.3 1998/06/08 15:14:56 ss Exp $ */
#ifndef SS_SOCKET_UTIL
#define SS_SOCKET_UTIL

#include "SocketTypes.h"

/** malloc some memory */
extern void *Sock_Malloc(int);
/** prevent SIGPIPE from ending program */
extern void Sock_SigPipeHandle();
/** Delay packet to meet max bandwidth requirements */
extern int Sock_DelayPacket(timeval *, int, int, int);
/** determine broadcast address for a given address - not correctly done */
extern char *Sock_BroadcastAddr(char *);
/** determine if passed string is an IP address */
extern int Sock_IsIPAddr(char *);
/** convert name/port to an sockaddr_in */
extern int Sock_NameToSin(char *, Port, Address *);
/** convert sockaddr_in to name/port */
extern int Sock_SinToName(char *, int, Port *, Address *);
/** convert time in usec to a timev */
extern timev *Sock_UtimeToTval(int );
/** convert a timev to time in usec */
extern int Sock_TvalToUtime(timev *);
/** difference in usec between to timev's */
extern int Sock_TimeDiff(timev, timev);

#endif
