/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/option/strtosize.c,v 1.2 1998/05/28 20:17:44 stemm Exp $ */
/***********************************************************************
 *
 * strtosize.c
 *
 *	strtobytes converts a string to a number of bytes.  It understands
 *	things like "K", "M", and so on as multiples of 1024.  The number
 *	returned is a 64 bit integer, but it may be truncated back to 32
 *	bits.
 *
 ***********************************************************************
 */

#ifndef lint
static char rcsid[] = "$Header: /home/stemm/cvs/option/strtosize.c,v 1.2 1998/05/28 20:17:44 stemm Exp $";
#endif /* not lint */

#include <ctype.h>

#ifndef	NULL
#define	NULL	((void*)0)
#endif

double
strtosize (s, endPtr)
char*	s;
char**	endPtr;
{
    double	result = 0.0;
    char*	curPos;
    int		endLoop = 0;
    double	curVal;

    if (s == NULL) {
	return (result);
    }

    while (!endLoop) {
	curVal = (double)strtol (s, &curPos, 0);
	if (curPos == s) {
	    endLoop = 1;
	} else {
	    s = curPos;
	    switch (toupper(*s)) {
	      case 'T':
		curVal *= 1024.0;
	      case 'G':
		curVal *= 1024.0;
	      case 'M':
		curVal *= 1024.0;
	      case 'K':
		curVal *= 1024.0;
		break;
	      default:
		break;
	    }
	    result += curVal;
	    if ((*s == '\0') || isspace(*s)) {
		endLoop = 1;
	    }
	}
    }
    if (endPtr != NULL) {
	*endPtr = s;
    }
    return (result);
}
