/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/porting/porting.c,v 1.3 1998/05/28 20:18:01 stemm Exp $ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <math.h>
#include <sys/time.h>

#include "porting.h"

void
microsleep(int usec) 
{
     struct timeval time1, time2;
#ifdef NANOSLEEP
     struct timespec sleepTime, left;
#endif
     static minUsleep = MIN_USLEEP;
     int temp;

     if (usec > minUsleep) {
	  gettimeofday(&time1, NULL);
#ifdef USLEEP
	  usleep(usec);
#else
#ifdef NANOSLEEP
	  sleepTime.tv_sec = usec/1000000;
	  sleepTime.tv_nsec = (usec % 1000000) * 1000;
	  nanosleep(&sleepTime, &left);
#else
	  sleep(usec/1000000);
#endif
#endif
	  gettimeofday(&time2, NULL);
	  temp = (time2.tv_usec - time1.tv_usec) +
	       (time2.tv_sec - time1.tv_sec) * 1000000;
	  if (temp > 1.25 * usec) {
	       debug_printf(109, "usec %d realWait %d minUsleep %d\n", 
		       usec, temp, minUsleep);
	       minUsleep = temp;
	  }
     }
}
